services:
  sedaq-db-postgres:
    image: 'postgres:14.3-alpine'
    container_name: sedaq-db-postgres
    restart: ${RESTART_POLICY}
    mem_limit: 1536MB
    mem_reservation: 1G
    environment:
      POSTGRES_USER: '${POSTGRES_USER}'
      POSTGRES_PASSWORD: '${POSTGRES_PASSWORD}'
      PGDATA: /var/lib/postgresql/data
    volumes:
      - 'db_sedaq_data:/var/lib/postgresql/data'
      - './db/db-init/:/docker-entrypoint-initdb.d/'
    ports:
      - '5432:5432'
    healthcheck:
      test:
        - CMD-SHELL
        - pg_isready -U ${POSTGRES_USER}
      interval: 30s
      timeout: 30s
      retries: 3
    networks:
      - sedaq-training
  sedaq-db-pgadmin4:
    image: 'dpage/pgadmin4:6.9'
    container_name: sedaq-db-pgadmin4
    restart: ${RESTART_POLICY}
    environment:
      PGADMIN_DEFAULT_EMAIL: '${PGADMIN_DEFAULT_EMAIL}'
      PGADMIN_DEFAULT_PASSWORD: '${PGADMIN_DEFAULT_PASSWORD}'
    volumes:
      - 'pgadmin_sedaq_data:/var/lib/pgadmin'
      - './db/pgadmin/bds-server.json:/pgadmin4/servers.json'
      - './db/pgadmin/pgpass:/pgadmin4/pgpass'
    ports:
      - '5050:80'
    depends_on:
      sedaq-db-postgres:
        condition: service_healthy
    networks:
      - sedaq-training
  sedaq-flyway:
    image: 'flyway/flyway:8.5.2-alpine'
    environment:
      - 'FLYWAY_USER=${POSTGRES_USER}'
      - 'FLYWAY_PASSWORD=${POSTGRES_PASSWORD}'
      - 'FLYWAY_URL=jdbc:postgresql://sedaq-db-postgres:5432/${DB_TRAINING}'
      - 'FLYWAY_SCHEMAS=${DB_TRAINING_SCHEMA_NAME}'
    command: '-locations=filesystem:/flyway/sql -connectRetries=60 migrate'
    volumes:
      - './db/migration/postgresql:/flyway/sql'
    depends_on:
      sedaq-db-postgres:
        condition: service_healthy
    networks:
      - sedaq-training
  nginx:
    image: 'nginx:1.21.6-alpine'
    container_name: sedaq-demo-nginx
    restart: ${RESTART_POLICY}
    volumes:
      - >-
        ./configuration/nginx-reverse-proxy/nginx.conf:/etc/nginx/conf.d/default.conf
    ports:
      - '80:80'
    depends_on:
      sedaq-db-pgadmin4:
        condition: service_started
    networks:
      - sedaq-training
volumes:
  db_sedaq_data:
    name: postgre-db-sedaq-data
  pgadmin_sedaq_data:
    name: postgre-pgadmin-sedaq-data  
networks:
  sedaq-training:
    name: sedaq-training
    driver: bridge
    driver_opts:
      com.docker.network.driver.mtu: 1500
